<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta charset="utf-8" />
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title>test for Diagram.draw</title>
<script type="text/javascript" src="../js.lib/DomTemplate.js"></script>
<script type="text/javascript" src="../js.lib/InvisibleRequest.js"></script>
<script type="text/javascript" src="../js.lib/Motion.js"></script>
<script type="text/javascript" src="../js.lib/wz_jsgraphics.js"></script>
<script type="text/javascript" src="../GitConfig.js"></script>
<script type="text/javascript" src="../GitBrowser.js"></script>
<script type="text/javascript" src="../GitDiagram.js"></script>
<script type="text/javascript" src="make-sample-trees.js"></script>
<script type="text/javascript">
/* <![CDATA[ */

g_base = RegExp("^https?://[^/?#]+","i").exec(document.location)[0];

function xdp( msg )
{
	var output=document.getElementById( "output" );
	output.appendChild( document.createElement( "DIV" ) ).appendChild( document.createTextNode( msg ) );
}

function diagram_node_kind_is_line( node )
{
	// a kludge, but if it has no "id", no children and the z-index is 3 return true
	if ( node.firstChild != null ) return false;
	if ( node.id != null && node.id != "" ) return false;
	if ( node.style == null || node.style.zIndex != 3 ) return false;
	return true;
}

function get_diagram_horizontal_lines( diagram_div )
{
	var lines=[];
	if ( diagram_div != null && diagram_div.firstChild != null ) {
		for( var node=diagram_div.firstChild.firstChild; node!=null; node=node.nextSibling ) {
			if( diagram_node_kind_is_line( node ) ) {
				lines.push( { left: node.style.left, top: node.style.top, width: node.clientWidth } );
			}
		}
	}
	return lines;
}

function test_draw( t )
{
	t.plan( 6 );
	t.open_window( "test-diagram-draw.html", function( wnd ) {
		t.delay_call( 3, function() {

			var diagram1_div=wnd.document.getElementById( "diagram1" );
			diagram1_div.style.width="400px";

			var diagram=new GitDiagram( { container_element: diagram1_div } );
			make_sample_tree1( diagram );
			make_sample_tree1a( diagram );
			diagram.place_nodes();
			diagram.draw();

			t.eq( get_diagram_horizontal_lines( diagram.m_container_element ).length, 6, "diagram horizontal line count" );
			t.eq( get_diagram_horizontal_lines( diagram.m_container_element ), [
				{ left: "162px", top: "24px", width: 42 }, { left: "191px", top: "2px", width: 13 }, { left: "144px", top: "90px", width: 95 }, { left: "210px", top: "68px", width: 13 },
				{ left: "216px", top: "46px", width: 7 }, { left: "255px", top: "112px", width: 0 }
				], "diagram horizontal lines" );

			diagram.m_window_offset={ x: 20, y: -100 };
			diagram.draw();
			t.eq( get_diagram_horizontal_lines( diagram1_div ).length, 6, "diagram div with offset horizontal line count" );
			t.eq( get_diagram_horizontal_lines( diagram1_div ), [
				{ left: "5px", top: "34px", width: 42 }, { left: "34px", top: "12px", width: 13 }, { left: "0px", top: "100px", width: 83 }, { left: "54px", top: "78px", width: 13 },
				{ left: "60px", top: "56px", width: 7 }, { left: "98px", top: "122px", width: 0 }
				], "diagram div with offset horizontal lines"
			);

			diagram.clear();
			make_sample_tree2( diagram );
			diagram.place_nodes();
			diagram.m_window_offset={ x: -100, y: -150 };
			diagram.draw();

			t.eq( get_diagram_horizontal_lines( diagram1_div ).length, 8, "diagram 2 div horizontal line count" );
			t.eq( get_diagram_horizontal_lines( diagram1_div ), [
				{ left: "107px", top: "150px", width: 160 }, { left: "237px", top: "128px", width: 0 }, { left: "222px", top: "128px", width: 0 }, { left: "191px", top: "128px", width: 9 },
				{ left: "169px", top: "128px", width: 0 }, { left: "148px", top: "128px", width: 0 }, { left: "113px", top: "172px", width: 139 }, { left: "119px", top: "194px", width: 7 }
				], "diagram 2 div horizontal lines"
			);
		} );
	} );
}

diagram1=null;
diagram2=null;

function init()
{
	if( diagram1==null ) {
		diagram1=new GitDiagram( { container_element: document.getElementById( "diagram1" ) } );
	}
	if( diagram2==null ) {
		diagram2=new GitDiagram( { container_element: document.getElementById( "diagram2" ) } );
	}
}
function draw1a()
{
	init();
	diagram1.clear();
	make_sample_tree1( diagram1 );
	make_sample_tree1a( diagram1 );
	diagram1.m_window_offset={ x: 20, y: -300 };
	diagram1.place_nodes();
	diagram1.draw();
}
function draw1b()
{
	init();
	diagram1.clear();
	make_sample_tree2( diagram1 );
	make_sample_tree2a( diagram1 );
	make_sample_tree2b( diagram1 );
	diagram1.m_window_offset={ x: -100, y: -300 };
	diagram1.place_nodes();
	diagram1.draw();
}
function draw_repo( diagram_name, repo_name, n )
{
	init();
	var diagram=null;
	if( diagram_name==diagram1.m_container_element.id ) {
		diagram=diagram1;
	}
	if( diagram_name==diagram2.m_container_element.id ) {
		diagram=diagram2;
	}
	if( diagram==null ) {
		alert( "bad diagram name: "+diagram_name );
		return;
	}
	diagram.clear();
	GitBrowser._g_server_url=g_base+"/git-browser/git-browser.cgi"; // this file is in not in the same directory as git-browser.cgi, and InvisibleRequest does not do relative paths.
	GitBrowser.call_server( { repo: repo_name, sub: "commits_from_refs", sub_args: { ref: ["r,all"] }, handler: function( result, repo_name ) {
			// sort it to make the shape deterministic.
			var tmp=[];
			for( var commit_id in result.commits ) {
				tmp.push( commit_id );
			}
			tmp.sort();
			for( var tmp_i=0; tmp_i<tmp.length; ++tmp_i ) {
				var commit=result.commits[tmp[tmp_i]];
				var time= commit.epoch==null ? commit.committer_epoch : commit.epoch;
				time=time*1000;
				diagram.add_node( commit.id, time, time, commit.author, commit.comment, commit.parents, repo_name );
			}
			diagram.place_nodes();
			diagram.draw();
	} } );
}

function draw_bug_1()
{
	init();
	diagram1.clear();
	make_bug_tree_1( diagram1 );
	diagram1.place_nodes();
	diagram1.draw();
}

/* ]]> */
</script>
<style type="text/css">
/* <![CDATA[ */
* { padding: 0; margin: 0 }
#diagram1 { position:absolute; left: 300px; top: 30px; width: 50%; height: 250px; border: 1px solid #090; }
#diagram2 { width: 80%; height: 250px; border: 1px solid #090; margin-top: 310px; margin-left: 5em; margin-right: 5em; }
.angle { position: absolute; left: 60px ; top: 450px; border-left: 20px solid #fff; border-bottom: 150px solid #ee8; }
.angleline { position: absolute; left: 59px; top: 450px; border-left: 20px solid #fff; border-bottom: 150px solid #000; }
/* ]]> */
</style>
</head>
<body>
<input type="button" value="draw1 a" onclick="draw1a();" />
<input type="button" value="draw1 b" onclick="draw1b();" />
<input type="button" value="draw bug 1" onclick="draw_bug_1();" />
<input type="button" value="draw 1 test" onclick="draw_repo( 'diagram1', 'test', 1000 );" />
<input type="button" value="draw 1 git" onclick="draw_repo( 'diagram1', 'git', 100 );" />
<div id="diagram1"></div>
<div id="diagram2"></div>
<input type="button" value="draw 2 test" onclick="draw_repo( 'diagram2', 'test', 1000 );" />
<input type="button" value="draw 2 git" onclick="draw_repo( 'diagram2', 'git', 100 );" />
<div id="output" style="width: 80%; margin-left: 20%" ></div>
<div id="angleline" class="angleline" style="display: none;"></div>
<div id="angle" class="angle" style="display: none;"></div>
</body>
</html>
